Index: /trunk/Assembly_Library/Inc/Display.inc
===================================================================
--- /trunk/Assembly_Library/Inc/Display.inc	(revision 84)
+++ /trunk/Assembly_Library/Inc/Display.inc	(revision 85)
@@ -211,4 +211,5 @@
 DOUBLE_LEFT_HORIZONTAL_TO_SINGLE_VERTICAL	EQU		181
 DOUBLE_RIGHT_HORIZONTAL_TO_SINGLE_VERTICAL	EQU		198
+SINGLE_VERTICAL								EQU		179
 SINGLE_HORIZONTAL							EQU		196
 SINGLE_LEFT_HORIZONTAL_TO_VERTICAL			EQU		180
Index: /trunk/Assembly_Library/Inc/DosFunctions.inc
===================================================================
--- /trunk/Assembly_Library/Inc/DosFunctions.inc	(revision 84)
+++ /trunk/Assembly_Library/Inc/DosFunctions.inc	(revision 85)
@@ -2,5 +2,5 @@
 ; Project name	:	AssemblyLibrary
 ; Created date	:	1.9.2010
-; Last update	:	8.10.2010
+; Last update	:	3.1.2011
 ; Author		:	Tomi Tilli
 ; Description	:	Defines for MS-DOS functions.
@@ -11,9 +11,9 @@
 DOS_INTERRUPT_21h									EQU		21h
 DOS_CRITICAL_ERROR_HANDLER_24h						EQU		24h
+DOS_TSR_MULTIPLEX_INTERRUPT_2Fh						EQU		2Fh
 
-; DOS file functions
+; DOS drive and file functions
 SELECT_DEFAULT_DRIVE								EQU		0Eh
 GET_CURRENT_DEFAULT_DRIVE							EQU		19h
-SET_INTERRUPT_VECTOR								EQU		25h
 GET_DISK_TRANSFER_AREA_ADDRESS						EQU		2Fh
 GET_DOS_DRIVE_PARAMETER_BLOCK_FOR_SPECIFIC_DRIVE	EQU		32h
@@ -27,4 +27,8 @@
 FIND_FIRST_MATCHING_FILE							EQU		4Eh
 FIND_NEXT_MATCHING_FILE								EQU		4Fh
+
+; DOS functions for TSRs
+SET_INTERRUPT_VECTOR								EQU		25h
+GET_INTERRUPT_VECTOR								EQU		35h
 
 ; DOS errors
Index: /trunk/Assembly_Library/Src/AssemblyLibrary.asm
===================================================================
--- /trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 84)
+++ /trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 85)
@@ -1,7 +1,3 @@
-; File name		:	AssemblyLibrary.asm
 ; Project name	:	Assembly Library
-; Created date	:	15.9.2010
-; Last update	:	24.10.2010
-; Author		:	Tomi Tilli
 ; Description	:	Assembly Library main file. This is the only file that
 ;					needs to be included.
@@ -72,8 +68,12 @@
 
 %ifdef INCLUDE_UTIL_LIBRARY
-	%include "Bit.asm"
+	%ifndef EXCLUDE_BIT_UTILS
+		%include "Bit.asm"
+	%endif
 	%include "Memory.asm"
 	%include "Registers.asm"
 	%include "Size.asm"
-	%include "Sort.asm"
+	%ifndef EXCLUDE_SORT_UTILS
+		%include "Sort.asm"
+	%endif
 %endif
Index: /trunk/Assembly_Library/Src/LibSizeCheck.asm
===================================================================
--- /trunk/Assembly_Library/Src/LibSizeCheck.asm	(revision 84)
+++ /trunk/Assembly_Library/Src/LibSizeCheck.asm	(revision 85)
@@ -1,19 +1,18 @@
-; File name		:	LibSizeCheck.asm
 ; Project name	:	Assembly Library
-; Created date	:	15.9.2010
-; Last update	:	11.12.2010
-; Author		:	Tomi Tilli
 ; Description	:	Tests for Assembly Library.
 ;					Builds wanted library functions to check their size.
 
 ; Include .inc files
-%define INCLUDE_DISPLAY_LIBRARY
+;%define INCLUDE_DISPLAY_LIBRARY
 ;%define INCLUDE_FILE_LIBRARY
 ;%define INCLUDE_KEYBOARD_LIBRARY
-;%define INCLUDE_MENU_LIBRARY
+%define INCLUDE_MENU_LIBRARY
 ;%define INCLUDE_MENU_DIALOGS
 ;%define INCLUDE_STRING_LIBRARY
 ;%define INCLUDE_TIME_LIBRARY
 ;%define INCLUDE_UTIL_LIBRARY
+
+%define EXCLUDE_BIT_UTILS
+%define EXCLUDE_SORT_UTILS
 %include "AssemblyLibrary.inc"	; Assembly Library. Must be included first!
 
Index: /trunk/Assembly_Library/Src/Time/TimerTicks.asm
===================================================================
--- /trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 84)
+++ /trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 85)
@@ -76,7 +76,7 @@
 ; TimerTicks_GetTimeoutTicksLeftToAXfromDSBX
 ;	Parameters:
-;		AX:			Number of ticks left before timeout
 ;		DS:BX:		Ptr to timeout variable WORD
 ;	Returns:
+;		AX:			Number of ticks left before timeout
 ;		CF:			Set if timeout
 ;					Cleared if time left
Index: /trunk/Assembly_Library/Src/Util/Size.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Size.asm	(revision 84)
+++ /trunk/Assembly_Library/Src/Util/Size.asm	(revision 85)
@@ -1,8 +1,12 @@
-; File name		:	Size.asm
 ; Project name	:	Assembly Library
-; Created date	:	7.9.2010
-; Last update	:	15.9.2010
-; Author		:	Tomi Tilli
 ; Description	:	Functions for size calculations.
+
+struc BYTE_MULTIPLES
+	.B			resb	1
+	.kiB		resb	1
+	.MiB		resb	1
+	.GiB		resb	1
+	.TiB		resb	1
+endstruc
 
 ; Section containing code
@@ -10,8 +14,8 @@
 
 ;--------------------------------------------------------------------
-; Size_GetWordSizeToAXfromBXDXAXwithMagnitudeInCX
+; Size_GetSizeToAXAndCharToDLfromBXDXAXwithMagnitudeInCX
 ;	Parameters:
 ;		BX:DX:AX:	Size in magnitude
-;		CX:			Magnitude (0=B, 1=kiB, 2=MiB...)
+;		CX:			Magnitude in BYTE_MULTIPLES
 ;	Returns:
 ;		AX:			Size in magnitude
@@ -52,9 +56,9 @@
 ;	Parameters:
 ;		BX:DX:AX:	Size
-;		CX:			Magnitude (0=B, 1=kiB, 2=MiB...)
+;		CX:			Magnitude in BYTE_MULTIPLES
 ;	Returns:
 ;		BX:DX:AX:	Size in magnitude
 ;		SI:			Remainder (0...1023)
-;		CX:			Magnitude (1=kiB, 2=MiB...)
+;		CX:			Magnitude in BYTE_MULTIPLES
 ;	Corrupts registers:
 ;		Nothing
@@ -121,5 +125,5 @@
 ; Size_GetMagnitudeCharacterToDLfromMagnitudeInCX
 ;	Parameters:
-;		CX:		Magnitude (0=B, 1=kiB, 2=MiB...)
+;		CX:		Magnitude in BYTE_MULTIPLES
 ;	Returns:
 ;		DL:		Magnitude character
Index: /trunk/Assembly_Library/makefile
===================================================================
--- /trunk/Assembly_Library/makefile	(revision 84)
+++ /trunk/Assembly_Library/makefile	(revision 85)
@@ -19,6 +19,6 @@
 
 # Assembly source code file (*.asm):
-SRC_ASM = Src/LibraryTests.asm
-#SRC_ASM = Src/LibSizeCheck.asm
+#SRC_ASM = Src/LibraryTests.asm
+SRC_ASM = Src/LibSizeCheck.asm
 
 # Program executable file name without extension: